-- user.e

include myLibs\myDebug.e
include myLibs\myConsole.e

------------------------------------------------------------------------------
-- USER CONSTANTS AND VARIABLES
--
-- in this section, you may put your own constants and variables

------------------------------------------------------------------------------

global constant
  MAX_LINES = 19,

  REAL = 1,
  CC_CURRENT = 2,
  CC_STATEMENT = 3,
  STATEMENT = 4,
  
  GRID_POINTER = 1,
  GRID_LINE = 2,
  GRID_OFFSET = 3,
  GRID_LENGTH = 4,
  GRID_PREVIOUS_LINE = 5,
  GRID_PREVIOUS_OFFSET = 6,
  GRID_DISPLAY_ROUTINE = 7

-- FICHIER OPERATIONS : ex UNTEL.$1
global constant
  OP_DATE = 1,
  OP_TYPE = 2,
  NUMBER = 3,
  PAYEE = 4,
  NOTES = 5,
  CAT = 6,
  SUBCAT = 7,
  AMOUNT = 8,
  VF = 9

global constant colonne = {2, 13, 22, 53, 69, 79}
global constant LongueurZone = {10, 8, 8, 30, 30, 15, 15, 9, 9, 1}
global constant ContenuZone = {OP_DATE, OP_TYPE, NUMBER, PAYEE, NOTES, CAT, SUBCAT, AMOUNT, AMOUNT, VF}
global constant FormatZone = {"%10s", "%-8s", "%-8s", "%-30s", "%-30s", "%-15s", "%-15s", "%-9.2f", "%9.2f", "%1s"}

global integer  Annee, Mois, Jour, RLimit, currentAcc
global sequence sUser, sAccount, accounts, operations, balances

------------------------------------------------------------------------------
-- CLASSES DEFINED
--

-- TMainMenu
--   sequence {menuF1,menuF2,menuF3,menuF4,menuF5,menuF6,menuF7,menuF8}
--   function setMenu(integer en, sequence params)
--   function displayMenu(integer en, sequence params)

-- TAccHeader
--   sequence {sAccount,sBalance}
--   function setAccHeader(integer en, sequence params)
--   function displayAccHeader(integer en, sequence params)

-- TAccFooter
--   sequence {sAccountStatement, account statement value,
--             sNetBalance, net balance value}
--   function setAccFooter(integer en, sequence params)
--   function displayAccFooter(integer en, sequence params)

-- TOpHeader
--   sequence {sDate,sType,sNumber,sPayee,sMemo,sCat,sSubCat,sDeposit,sWithdrawal,sStatus}
--   function setOpHeader(integer en, sequence params)
--   function displayOpHeader(integer en, sequence params)

-- TGrid
--   sequence {pointer, line, offset, length, previous_line, previous_offset, display_routine)
--   function gridLineDisplay(integer en, sequence params)
--   function gridDisplay(integer en, sequence params)
--   function gridSetPointer(integer en, sequence params)
--   function gridSetLine(integer en, sequence params)
--   function gridSetOffset(integer en, sequence params)
--   function gridSetLength(integer en, sequence params)
--   function gridSetPreviousOffset(integer en, sequence params)
--   function gridSetPreviousLength(integer en, sequence params)
--   function gridGetPointer(integer en, sequence params)
--   function gridGetLine(integer en, sequence params)
--   function gridGetOffset(integer en, sequence params)
--   function gridGetLength(integer en, sequence params)
--   function gridGoFirst(integer en, sequence params)
--   function gridGoPrevious(integer en, sequence params)
--   function gridGoNext(integer en, sequence params)
--   function gridGoLast(integer en, sequence params)

-- TOpFooter
--   sequence {sCardStatement, card statement value,
--             sAccountStatement, account statement value,
--             sCardOutstanding, card outstanding value,
--             sNetBalance, net balance value}
--   function setOpFooter(integer en, sequence params)
--   function displayOpFooter(integer en, sequence params)

-- TStatusBar
--   sequence {user name, account name, pointer, number of operations}
--   function setStatusBar(integer en, sequence params)
--   function displayStatusBar(integer en, sequence params)

------------------------------------------------------------------------------
-- CLASS FUNCTIONS
--
-- in this section, you have to put your own functions
-- function parameters are ALLWAYS (integer en, sequence params) -- MANDATORY
-- the variables contained in the specified entity are located in the
-- sequence entities[en][ENTITY_VALUES]
------------------------------------------------------------------------------

------------------------------------------------------------------------------
-- Main Menu
------------------------------------------------------------------------------

-- set main Menu
global function setMenu(integer en, sequence params)
  entities[en][ENTITY_VALUES] = params
  return 0
end function

------------------------------------------------------------------------------

-- display main Menu
global function displayMenu(integer en, sequence params)
  -- params is required but ignored
  sequence s

  s = entities[en][ENTITY_VALUES]
  printAt({1, 1}, "F1ĿF2ĿF3ĿF4ĿF5ĿF6ĿF7ĿF8Ŀ", "%s", {YELLOW, BLUE})
  printAt({2, 1}, "                                                                ", "%s", {YELLOW, BLUE})
  printAt({3, 1}, "", "%s", {YELLOW, BLUE})
  for i =1 to 8 do printAt({2, 2+10*(i-1)}, s[i], "%s", {YELLOW, BLUE}) end for
  return 0
end function


------------------------------------------------------------------------------
-- Accounts Header
------------------------------------------------------------------------------

-- set Accounts Header
global function setAccHeader(integer en, sequence params)
  entities[en][ENTITY_VALUES] = params
  return 0
end function

------------------------------------------------------------------------------

-- display Accounts Header
global function displayAccHeader(integer en, sequence params)
  -- params is required but ignored
  sequence s

  s = entities[en][ENTITY_VALUES]
--                  0        1         2         3         4         5         6         7         8
--                  12345678901234567890123456789012345678901234567890123456789012345678901234567890
  printAt({4, 1}, "Ŀ", "%s", {GRAY, WHITE})
  printAt({5, 1}, "                                                                             ", "%s", {GRAY, WHITE})
  printAt({6, 1}, "                                                                             ", "%s", {GRAY, WHITE})
  printAt({7, 1}, "Ĵ", "%s", {GRAY, WHITE})
  printAt({5, 2}, s[1], "%s", {BLACK, WHITE})
  printAt({5,69}, s[2], "%s", {BLACK, WHITE})
  return 0
end function


------------------------------------------------------------------------------
-- Accounts Footer
------------------------------------------------------------------------------

-- set Accounts Footer
global function setAccFooter(integer en, sequence params)
  entities[en][ENTITY_VALUES] = params
  return 0
end function

------------------------------------------------------------------------------

-- display Accounts Footer
global function displayAccFooter(integer en, sequence params)
  -- params is required but ignored
  sequence s

  s = entities[en][ENTITY_VALUES]
--                  0        1         2         3         4         5         6         7         8
--                  12345678901234567890123456789012345678901234567890123456789012345678901234567890
  printAt({46, 1}, "Ĵ", "%s", {GRAY, WHITE})
  printAt({47, 1}, "                              FreeBudget v1.3                               ", "%s", {GRAY, WHITE})
  printAt({48, 1}, "                                                                            ", "%s", {GRAY, WHITE})
  printAt({49, 1}, "", "%s", {GRAY, WHITE})
  printAt({48, 2}, s[1], "%12s",  {BLACK, WHITE})     -- Account Statement
  printAt({48,17}, s[2], "%10.2f", {BRIGHT_WHITE, WHITE})
  printAt({48,53}, s[3], "%12s",  {BLACK, WHITE})     -- Net Balance
  printAt({48,68}, s[4], "%10.2f", {BRIGHT_WHITE, WHITE})
  return 0
end function


------------------------------------------------------------------------------
-- Operations Header
------------------------------------------------------------------------------

-- set Header
global function setOpHeader(integer en, sequence params)
  entities[en][ENTITY_VALUES] = params
  return 0
end function

------------------------------------------------------------------------------

-- display Operations Header
global function displayOpHeader(integer en, sequence params)
  -- params is required but ignored
  sequence s
  
  s = entities[en][ENTITY_VALUES]
--                  0        1         2         3         4         5         6         7         8
--                  12345678901234567890123456789012345678901234567890123456789012345678901234567890
--                   0        1 0        0        1         2         3 0        1      0         0
--                   1234567890 12345678 123456789012345678901234567890 123456789012345 123456789 1
  printAt({4,  1}, "Ŀ", "%s", {GRAY, WHITE})
  printAt({5,  1}, "                                                                         ", "%s", {GRAY, WHITE})
  printAt({6,  1}, "                                                                         ", "%s", {GRAY, WHITE})
  printAt({7,  1}, "Ĵ", "%s", {GRAY, WHITE})
  printAt({5,  2}, s[1], "%s", {BLACK, WHITE})
  printAt({5, 13}, s[2], "%s", {BLACK, WHITE})
  printAt({6, 13}, s[3], "%s", {BLACK, WHITE})
  printAt({5, 22}, s[4], "%s", {BLACK, WHITE})
  printAt({6, 22}, s[5], "%s", {BLACK, WHITE})
  printAt({5, 53}, s[6], "%s", {BLACK, WHITE})
  printAt({6, 53}, s[7], "%s", {BLACK, WHITE})
  printAt({5, 69}, s[8], "%s", {BLACK, WHITE})
  printAt({6, 69}, s[9], "%s", {BLACK, WHITE})
  printAt({5, 79}, s[10], "%s", {BLACK, WHITE})
  return 0
end function


------------------------------------------------------------------------------
-- Grid
------------------------------------------------------------------------------

procedure displayAccount(integer i, integer ligne, integer ok)
  integer first, secnd
  integer paper, ink

  if (ligne<1) or (ligne>(2*MAX_LINES)) then
    return
  end if
  if remainder(i, 2) = 0 then
    paper = CYAN
  else
    paper = WHITE
  end if
  first = 8+2*(ligne-1)
  secnd = first + 1

  if ok then
    ink = BLUE
  else
    ink = BLACK
  end if
  printAt({first, 1}, "                                                                             ", "%s", {GRAY, paper})
  printAt({secnd, 1}, "                                                                             ", "%s", {GRAY, paper})
  if (i > 0) and (i <= length(accounts)) then
    printAt({first, 2}, accounts[i], "%s", {ink, paper})
    printAt({first, 69}, balances[i][REAL], "%10.2f", {ink, paper})
  end if
  if ok then
    position(first, 2)
  end if
end procedure

------------------------------------------------------------------------------

procedure displayOperation(integer i, integer ligne, integer ok)
  integer first, secnd
  integer paper, ink
  sequence s

  if (ligne<1) or (ligne>MAX_LINES) then
    return
  end if
  if remainder(i, 2) = 0 then
    paper = CYAN
  else
    paper = WHITE
  end if
  first = 8+2*(ligne-1)
  secnd = first + 1

  if ok then
    ink = BRIGHT_WHITE
  else
    ink = BLACK
  end if
  printAt({first, 1}, "                                                                         ", "%s", {GRAY, paper})
  printAt({secnd, 1}, "                                                                         ", "%s", {GRAY, paper})
  if currentAcc > 0 then
    if (i > 0) and (i <= length(operations[currentAcc])) then
      s = repeat('/', 10)
      s[1..2] = operations[currentAcc][i][OP_DATE][7..8]
      s[4..5] = operations[currentAcc][i][OP_DATE][5..6]
      s[7..10] = operations[currentAcc][i][OP_DATE][1..4]
      printAt({first, colonne[1]}, s, FormatZone[1], {ink, paper})
      printAt({first, colonne[2]}, operations[currentAcc][i][OP_TYPE], FormatZone[2], {ink, paper})
      printAt({secnd, colonne[2]}, operations[currentAcc][i][NUMBER], FormatZone[3], {ink, paper})
      printAt({first, colonne[3]}, operations[currentAcc][i][PAYEE], FormatZone[4], {ink, paper})
      printAt({secnd, colonne[3]}, operations[currentAcc][i][NOTES], FormatZone[5], {ink, paper})
      printAt({first, colonne[4]}, operations[currentAcc][i][CAT], FormatZone[6], {ink, paper})
      printAt({secnd, colonne[4]}, operations[currentAcc][i][SUBCAT], FormatZone[7], {ink, paper})
      if operations[currentAcc][i][AMOUNT] >= 0 then
        printAt({first, colonne[5]}, operations[currentAcc][i][AMOUNT], FormatZone[8], {ink, paper})
      else
	   printAt({secnd, colonne[5]}, -operations[currentAcc][i][AMOUNT], FormatZone[9], {ink, paper})
      end if
      if i < RLimit then
	paper = RED
      end if
      printAt({first, colonne[6]}, operations[currentAcc][i][VF], FormatZone[10], {ink, paper})
      printAt({secnd, colonne[6]}, " ", FormatZone[10], {ink, paper})
    end if
    if ok then
      position(first, 2)
    end if
  end if
end procedure

------------------------------------------------------------------------------

-- set Grid Pointer
global function gridSetPointer(integer en, sequence params)
puts(f_debug, "gridSetPointer\n")
  entities[en][ENTITY_VALUES][GRID_POINTER] = params[1]
analyzeSequence(entities[en], "entities[en]", f_debug)
  return 0
end function

------------------------------------------------------------------------------

-- set Grid Line
global function gridSetLine(integer en, sequence params)
puts(f_debug, "gridSetLine\n")
  entities[en][ENTITY_VALUES][GRID_PREVIOUS_LINE] = entities[en][ENTITY_VALUES][GRID_LINE]
  entities[en][ENTITY_VALUES][GRID_LINE] = params[1]
analyzeSequence(entities[en], "entities[en]", f_debug)
  return 0
end function

------------------------------------------------------------------------------

-- set Grid Offset
global function gridSetOffset(integer en, sequence params)
puts(f_debug, "gridSetOffset\n")
  entities[en][ENTITY_VALUES][GRID_PREVIOUS_OFFSET] = entities[en][ENTITY_VALUES][GRID_OFFSET]
  entities[en][ENTITY_VALUES][GRID_OFFSET] = params[1]
analyzeSequence(entities[en], "entities[en]", f_debug)
  return 0
end function


------------------------------------------------------------------------------

-- set Grid Previous Line
global function gridSetPreviousLine(integer en, sequence params)
puts(f_debug, "gridSetPreviousLine\n")
  entities[en][ENTITY_VALUES][GRID_PREVIOUS_LINE] = params[1]
analyzeSequence(entities[en], "entities[en]", f_debug)
  return 0
end function

------------------------------------------------------------------------------

-- set Grid Previous Offset
global function gridSetPreviousOffset(integer en, sequence params)
puts(f_debug, "gridSetPreviousOffset\n")
  entities[en][ENTITY_VALUES][GRID_PREVIOUS_OFFSET] = params[1]
analyzeSequence(entities[en], "entities[en]", f_debug)
  return 0
end function

------------------------------------------------------------------------------

-- set Grid Length
global function gridSetLength(integer en, sequence params)
puts(f_debug, "gridSetLength\n")
  entities[en][ENTITY_VALUES][GRID_LENGTH] = params[1]
analyzeSequence(entities[en], "entities[en]", f_debug)
  return 0
end function

------------------------------------------------------------------------------

-- set Grid Line Display routine
global function gridLineDisplay(integer en, sequence params)
puts(f_debug, "gridLineDisplay\n")
  entities[en][ENTITY_VALUES][GRID_DISPLAY_ROUTINE] = routine_id(params)
analyzeSequence(entities[en], "entities[en]", f_debug)
  return 0
end function

------------------------------------------------------------------------------

-- get Grid Pointer
global function gridGetPointer(integer en, sequence params)
  return entities[en][ENTITY_VALUES][GRID_POINTER]
end function

------------------------------------------------------------------------------

-- get Grid Line
global function gridGetLine(integer en, sequence params)
  return entities[en][ENTITY_VALUES][GRID_LINE]
end function

------------------------------------------------------------------------------

-- get Grid Offset
global function gridGetOffset(integer en, sequence params)
  return entities[en][ENTITY_VALUES][GRID_OFFSET]
end function

------------------------------------------------------------------------------

-- get Grid Length
global function gridGetLength(integer en, sequence params)
  return entities[en][ENTITY_VALUES][GRID_LENGTH]
end function

------------------------------------------------------------------------------

global function gridGoFirst(integer en, sequence params)
  sequence s

  s = entities[en][ENTITY_VALUES]
  if s[GRID_LENGTH]=0 then return 1 end if
  entities[en][ENTITY_VALUES][GRID_POINTER] = 1
  entities[en][ENTITY_VALUES][GRID_LINE] = 1
  entities[en][ENTITY_VALUES][GRID_OFFSET] = 0
  return 0
end function

------------------------------------------------------------------------------

global function gridGoPrevious(integer en, sequence params)
  sequence s

  s = entities[en][ENTITY_VALUES]
  if s[GRID_LENGTH]=0 then return 1 end if
  if s[GRID_POINTER]=1 then return 0 end if
  entities[en][ENTITY_VALUES][GRID_POINTER] = s[GRID_POINTER] - 1
  if s[GRID_LINE]=1 then
    entities[en][ENTITY_VALUES][GRID_OFFSET] = s[GRID_OFFSET] - 1
  else
    entities[en][ENTITY_VALUES][GRID_LINE] = s[GRID_LINE] - 1
  end if
  return 0
end function

------------------------------------------------------------------------------

global function gridGoNext(integer en, sequence params)
  sequence s

  s = entities[en][ENTITY_VALUES]
  if s[GRID_LENGTH]=0 then return 1 end if
  if s[GRID_POINTER]=s[GRID_LENGTH] then return 0 end if
  entities[en][ENTITY_VALUES][GRID_POINTER] = s[GRID_POINTER] + 1
--  if s[GRID_LINE]=MAX_LINES-1 then
  if s[GRID_LINE]=MAX_LINES then
    entities[en][ENTITY_VALUES][GRID_OFFSET] = s[GRID_OFFSET] + 1
  else
    entities[en][ENTITY_VALUES][GRID_LINE] = s[GRID_LINE] + 1
  end if
  return 0
end function

------------------------------------------------------------------------------

global function gridGoLast(integer en, sequence params)
  sequence s
  object void

  s = entities[en][ENTITY_VALUES]
  if s[GRID_LENGTH]=0 then return 1 end if
  if s[GRID_LENGTH]=0 then
    entities[en][ENTITY_VALUES][GRID_LINE] = 0
    entities[en][ENTITY_VALUES][GRID_POINTER] = 0
    entities[en][ENTITY_VALUES][GRID_OFFSET] = 0
    return 0
  end if
  if s[GRID_LENGTH] >= MAX_LINES then
    entities[en][ENTITY_VALUES][GRID_LINE] = MAX_LINES
    entities[en][ENTITY_VALUES][GRID_OFFSET] = s[GRID_LENGTH]-MAX_LINES
  else
    void = gridGoFirst(en, params)
    entities[en][ENTITY_VALUES][GRID_LINE] = s[GRID_LENGTH]
  end if
  entities[en][ENTITY_VALUES][GRID_POINTER] = s[GRID_LENGTH]
  return 0
end function

------------------------------------------------------------------------------

-- display Operations Grid
global function gridDisplay(integer en, sequence params)
  -- params is required but ignored
  sequence s

puts(f_debug, "gridDisplay\n")
analyzeSequence(entities[en], "entities[en]", f_debug)
  s = entities[en][ENTITY_VALUES]
  for i = 1 to MAX_LINES do
    if i = s[GRID_LINE] then
      call_proc(s[GRID_DISPLAY_ROUTINE], {s[GRID_OFFSET]+i, i, 1})
    else
      call_proc(s[GRID_DISPLAY_ROUTINE], {s[GRID_OFFSET]+i, i, 0})
    end if
  end for
  entities[en][ENTITY_VALUES][GRID_PREVIOUS_OFFSET] = s[GRID_OFFSET]
  return 0
end function


------------------------------------------------------------------------------
-- Operations Footer
------------------------------------------------------------------------------

-- set Operations Footer
global function setOpFooter(integer en, sequence params)
  entities[en][ENTITY_VALUES] = params
  return 0
end function

------------------------------------------------------------------------------

-- display Operations Footer
global function displayOpFooter(integer en, sequence params)
  -- params is required but ignored
  sequence s

  s = entities[en][ENTITY_VALUES]
--                  0        1         2         3         4         5         6         7         8
--                  12345678901234567890123456789012345678901234567890123456789012345678901234567890
  printAt({46,  1}, "Ĵ", "%s", {GRAY, WHITE})
  printAt({47,  1}, "                              FreeBudget v1.3                               ", "%s", {GRAY, WHITE})
  printAt({48,  1}, "                                                                            ", "%s", {GRAY, WHITE})
  printAt({49,  1}, "", "%s", {GRAY, WHITE})
  printAt({47,  2}, s[1], "%s", {BLACK, WHITE})
  printAt({47, 17}, s[2], "%10.2f", {BRIGHT_WHITE, WHITE})
  printAt({48,  2}, s[3], "%s", {BLACK, WHITE})
  printAt({48, 17}, s[4], "%10.2f", {BRIGHT_WHITE, WHITE})
  printAt({47, 53}, s[5], "%s", {BLACK, WHITE})
  printAt({47, 68}, s[6], "%10.2f", {BRIGHT_WHITE, WHITE})
  printAt({48, 53}, s[7], "%s", {BLACK, WHITE})
  printAt({48, 68}, s[8], "%10.2f", {BRIGHT_WHITE, WHITE})
  return 0
end function


------------------------------------------------------------------------------
-- StatusBar
------------------------------------------------------------------------------

-- set StatusBar
global function setStatusBar(integer en, sequence params)
  entities[en][ENTITY_VALUES] = params
  return 0
end function

------------------------------------------------------------------------------

-- display StatusBar
global function displayStatusBar(integer en, sequence params)
  -- params is required but ignored
  sequence s, sStatusBar

  s = entities[en][ENTITY_VALUES]
--  0        1         2         3         4         5         6         7         8
--  12345678901234567890123456789012345678901234567890123456789012345678901234567890
-- " --/--/----  ----------- : --------  ------- : --------------------  ---/--- "
  sStatusBar = sprintf(" %02d/%02d/%04d  %11s : %-8s  %7s : %-20s  %3d/%-3d" , {Jour,Mois,Annee+1900,sUser,s[1],sAccount,s[2],s[3],s[4]})
  bk_color(RED)
  position(50,1) clrEol()
  printAt({50, 1}, sStatusBar, "%s", {15, 4})
  bk_color(WHITE)
  return 0
end function

------------------------------------------------------------------------------

